#include <unistd.h>
#include <cstdio>
#include <pthread.h>

#include <iostream>

#include "DioBuffer.hh"
#include "DioThread.hh"
#include "OnlReader.hh"
#include "OnlWriter.hh"
#include "OnlSampler.hh"

using namespace std;

int main() {
  OnlReader r(OnlReader::bin);
  r.open("../../../dual/src/driverFile");
  //DioConnector<RcdArena> c;
  //OnlSampler c(344567);
  DioBuffer<RcdArena> c(344566);
  OnlWriter w(OnlWriter::bin);

  DioThread<RcdArena> t0(r,c);
  t0.create();

  DioThread<RcdArena> t1(c,w);
  t1.create();

  t0.join();
  t1.join();

  return 0;
}
