#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <fcntl.h>
#include <unistd.h>

#include <iostream>
#include <sstream>
#include <vector>
#include <cstdio>

#include "VMEAddressTable.hh"
#include "VMEAddressTableASCIIReader.hh"
#include "SBS620x86LinuxBusAdapter.hh"
#include "HardwareAccessException.hh"

#include "BmlLc1176VmeDevice.hh"

using namespace std;

int main(int argc, const char **argv) {

  VMEAddressTableASCIIReader addressTableReader("online/hal/Lc1176VmeAddress.hal");
  VMEAddressTable addressTable("LC1176 VME Address Table",addressTableReader);

  for(unsigned p(0);p<2;p++) {
    try{
      SBS620x86LinuxBusAdapter busAdapter(p);
      cout << "PCI card " << p << " is alive" << endl;
      
      for(unsigned i(0);i<256;i++) {
	BmlLc1176VmeDevice dev(addressTable,busAdapter,i);
	dev.write("CSR",0x00800000);
	dev.reset();
	dev.clear();
	if(dev.alive()) cout << "  LC1176 at address 0x"
			     << setw(2) << hex << i << dec << "0000 is alive" << endl;
	//else cout << "  LC1176 at address 0x"
	//		     << setw(2) << hex << i << dec << "0000 is NOT alive" << endl;
      }

    } catch ( HardwareAccessException& e ) {
      //cout << "*** Exception occurred : " << endl;
      //cout << e.what() << " I Made This" << endl;
      
    } catch ( exception e ) {
      //cout << "*** Unknown exception occurred" << endl;
    }
  }
}
